#!/usr/bin/ruby
# encoding: utf-8

class AntibotMisc
	
	def AntibotMisc.machine_id
		manufacturer = ` dmidecode -s system-manufacturer `
		type = ` dmidecode -s system-product-name `
		version = ` dmidecode -s system-version `
		uuid = ` dmidecode -s system-uuid `
		mid = manufacturer.strip
		mid = mid + " " + type.strip unless type =~ /^none/i
		mid = mid + " " + version.strip unless version =~ /^none/i 
		mid = mid + " " + uuid.strip.downcase
		return mid 
	end

	def AntibotMisc.boot_options
		retval = Hash.new
		retval["debug"] = false
		retval["internal"] = false
		bootline = ` cat /proc/cmdline `.strip.split
		bootline.each { |t|
			if t =~ /^antibot=/
				btoks = t.split('|')
				btoks.each { |b|
					retval["debug"] = true if b.strip == "debug"
					retval["internal"] = true if b.strip == "internal"
				}
			end
		}
		return retval 
	end

end